{ lib
, plugins
, hop-nvim
, nvim-orgmode
, nvim-colorizer
, org-bullets-nvim
, enableOrgMode ? false
, ...
}:

let
  inherit (builtins) readFile;

  hopLuaConfig = readFile ./hop-nvim.lua;

  orgmodeEnable = lib.attrByPath [ "orgmode" "enable" ] enableOrgMode plugins;
  orgmodeSettings = lib.toLua (lib.attrByPath [ "orgmode" "settings" ] { } plugins);
  orgmodeLuaConfig = lib.optionalString orgmodeEnable
    (lib.readSubFile ./nvim-orgmode.lua { inherit orgmodeSettings; });

  colorizerFiletypes = lib.toLua (lib.attrByPath [ "colorizer" "filetypes" ] lib.LuaNil plugins);
  colorizerSettings = lib.toLua (lib.attrByPath [ "colorizer" "settings" ] lib.LuaNil plugins);
  colorizerLuaConfig = lib.readSubFile ./nvim-colorizer.lua
    { inherit colorizerFiletypes colorizerSettings; };

in
{
  luaConfig = hopLuaConfig + orgmodeLuaConfig + colorizerLuaConfig;

  plugins = [ hop-nvim nvim-colorizer ]
    ++ lib.optionals orgmodeEnable [ nvim-orgmode org-bullets-nvim ];
}
